require "class"
require "screens/pausescreen"
local easing = require "easing"

local trace = function() end

local CLICK_WALK_TIME = .5

local prefabs =
{
}
local galun = Class(function(self, inst)
    self.inst = inst
    self.inst:StartUpdatingComponent(self)
end)


local function destroy_galun(inst, times)
	if inst.components.combat then inst.components.combat:GiveUp() end
	local time_to_erode = times or 1 + math.random()*3
	
	local tick_time = TheSim:GetTickTime()

	if inst.DynamicShadow then
        inst.DynamicShadow:Enable(false)
    end

	inst:StartThread( function()
		local ticks = 0
		while ticks * tick_time < time_to_erode do
			local erode_amount = ticks * tick_time / time_to_erode
			inst.AnimState:SetErosionParams( erode_amount, 0.1, 1.0 )
			ticks = ticks + 1
			Yield()
		end
		inst:Remove()
	end)
end

local function SpawnEffect2(inst)
    inst:DoTaskInTime(0.5, function() 
					inst:AddTag("NOCLICK")
					if inst.components.combat then
    inst:DoTaskInTime(0.5, function() 
        inst.components.combat:GiveUp()end)
		end
			
    end)
end

function galun:OnUpdate(dt)
if self.inst:HasTag("sword_attacker") then
-----print("no del helper")
return
end

if self.inst.components.combat then
    if (self.inst.LightWatcher:GetLightValue() > 0.5 and GetClock():IsNight()) or (self.inst:GetDistanceSqToInst(GetPlayer()) < (2*2)) then
 		SpawnEffect2(self.inst)
		self.inst:DoTaskInTime(1, destroy_galun)
	end
elseif (self.inst:GetDistanceSqToInst(GetPlayer()) < (8*8)) then
	self.inst:DoTaskInTime(0.5, destroy_galun)
-----	print("destroy ITEM")
end
end


return galun
