local brain = require "brains/skw_brain"

local assets =
{
	Asset("ANIM", "anim/player_basic.zip"),
        Asset("ANIM", "anim/player_idles_shiver.zip"),
        Asset("ANIM", "anim/player_actions.zip"),
        Asset("ANIM", "anim/player_actions_axe.zip"),
        Asset("ANIM", "anim/player_actions_pickaxe.zip"),
        Asset("ANIM", "anim/player_actions_shovel.zip"),
        Asset("ANIM", "anim/player_actions_blowdart.zip"),
        Asset("ANIM", "anim/player_actions_eat.zip"),
        Asset("ANIM", "anim/player_actions_item.zip"),
        Asset("ANIM", "anim/player_cave_enter.zip"),
        Asset("ANIM", "anim/player_actions_uniqueitem.zip"),
        Asset("ANIM", "anim/player_actions_bugnet.zip"),
        Asset("ANIM", "anim/player_actions_fishing.zip"),
        Asset("ANIM", "anim/player_actions_boomerang.zip"),
        Asset("ANIM", "anim/player_bush_hat.zip"),
        Asset("ANIM", "anim/player_attacks.zip"),
        Asset("ANIM", "anim/player_idles.zip"),
        Asset("ANIM", "anim/player_rebirth.zip"),
        Asset("ANIM", "anim/player_jump.zip"),
        Asset("ANIM", "anim/player_amulet_resurrect.zip"),
		Asset("ANIM", "anim/player_teleport.zip"),
        Asset("ANIM", "anim/wilson_fx.zip"),
        Asset("ANIM", "anim/player_one_man_band.zip"),
        Asset("ANIM", "anim/player_slurtle_armor.zip"),
        Asset("ANIM", "anim/player_staff.zip"),
	Asset("ANIM", "anim/wilton.zip"),
        

		Asset("ANIM", "anim/shadow_hands.zip"),

        Asset("SOUND", "sound/sfx.fsb"),
        Asset("SOUND", "sound/wilton.fsb"),
}

local prefabs =
{

}

local WEAPONS = {"cane","axe", "spear","multitool_axe_pickaxe","goldenaxe","shovel","goldenshovel","pickaxe","goldenpickaxe","boomerang","nightsword","torch","hammer","pitchfork"}
local ARMOR = {"armorwood","armorgrass","sweatervest","armormarble","armorsanity","armorwood","trunkvest_summer","trunkvest_winter","sweatervest"}
local HAT = {"strawhat","tophat","winterhat","beehat","beefalohat","flowerhat"}

local function ontalk(inst, script)
	if not inst:HasTag("cdlfss") then
	inst:AddTag("cdlfss")
	inst.SoundEmitter:PlaySound("dontstarve/characters/wilton/talk_LP","skw_sound")
	inst:DoTaskInTime(1.8, function()
	inst.SoundEmitter:KillSound("skw_sound")
	
    inst:RemoveTag("cdlfss")
    end)
	end
end
local function ShouldAcceptItem(inst, item)
	local currenthealth = inst.components.health.currenthealth / inst.components.health.maxhealth
    	if item.components.equippable and (item.components.equippable.equipslot == EQUIPSLOTS.HEAD or item.components.equippable.equipslot == EQUIPSLOTS.HANDS or item.components.equippable.equipslot == EQUIPSLOTS.BODY) and not item.components.projectile then
		if item.prefab == "batbat" then
			print ("refusing batbat")
			return false
		end
        	return true
   	end
end

local function OnGetItemFromPlayer(inst, giver, item)
    	if item.components.equippable and (item.components.equippable.equipslot == EQUIPSLOTS.HEAD or item.components.equippable.equipslot == EQUIPSLOTS.HANDS or item.components.equippable.equipslot == EQUIPSLOTS.BODY)   then     
		local newslot = item.components.equippable.equipslot
		local current = inst.components.inventory:GetEquippedItem(newslot)
		if current then
            		inst.components.inventory:DropItem(current)
        	end      
        	inst.components.inventory:Equip(item)
    	end
end

local function OnRefuseItem(inst, item)
    inst.sg:GoToState("refuse")
    local playerprefab = GetPlayer()
    local actualprefab = playerprefab.prefab
    inst.components.talker:Say(GetString(actualprefab, "ACTIONFAIL_GENERIC"))
end
--[[       
local function NormalRetargetFn(inst,typeof)
local daymult = 1
local nighmult = 1
local attack_ee = 0
if typeof == 1 or typeof == 5 then
attack_ee = 1
daymult = 1.5
nighmult = 1.5

elseif typeof == 2 then
daymult = 0.45
nighmult = 0.45
elseif typeof == 3 then
daymult = 3
nighmult = 1.5
elseif typeof == 4 then
daymult = 1.25
nighmult = 0.75
end

if GetClock():IsNight() or attack_ee == 1 then
	print("night and everyone")

    return FindEntity(inst, TUNING.PIG_TARGET_DIST*nighmult,


        function(guy)
                return guy.components.health and not guy.components.health:IsDead() and inst.components.combat:CanTarget(guy)
        end)
		
		
else
			print("day")

    return FindEntity(inst, TUNING.PIG_TARGET_DIST*daymult,
        function(guy)
                return guy:HasTag("monster") and guy.components.health and not guy.components.health:IsDead() and inst.components.combat:CanTarget(guy)
        end)
		end
end
--]]


local function OnEat(inst, food)
    if food.components.edible
       and food.components.edible.foodtype == "MEAT"
       and inst.components.werebeast
       and not inst.components.werebeast:IsInWereState() then
        if food.components.edible:GetHealth() < 0 then
            inst.components.werebeast:TriggerDelta(1)
        end
    end
    
    if food.components.edible and food.components.edible.foodtype == "VEGGIE" then
	end
    
end


local function ondeath(inst,deadthing)
if inst == deadthing then

	SpawnPrefab("collapse_big").Transform:SetPosition(inst.Transform:GetWorldPosition()) --the titular poof

	inst:DoTaskInTime(1, function() 
    local rabbit = SpawnPrefab("skeleton")
	
    rabbit.Transform:SetPosition(inst.Transform:GetWorldPosition())
	local lightning = SpawnPrefab("lightning")
	lightning.Transform:SetPosition(rabbit.Transform:GetWorldPosition())
	
	local dpt = inst.components.knownlocations:GetLocation("home") 

	local lightning = SpawnPrefab("lightning")
	lightning.Transform:SetPosition(dpt.x +math.random(-1,1), dpt.y, dpt.z+math.random(-1,1))
	local lightning = SpawnPrefab("lightning")
	lightning.Transform:SetPosition(dpt.x +math.random(-4,4), dpt.y, dpt.z+math.random(-4,4))
	local lightning = SpawnPrefab("lightning")
	lightning.Transform:SetPosition(dpt.x +math.random(-7,7), dpt.y, dpt.z+math.random(-7,7))
	
            inst:Remove()
			
			
    end)
end--]]
end

--[[
local function NormalRetargetfn(inst)
    local targetDist = TUNING.SPIDER_TARGET_DIST

    return FindEntity(inst, targetDist, 
        function(guy) 
            if inst.components.combat:CanTarget(guy)
               and not (inst.components.follower and inst.components.follower.leader == guy) then
                return guy:HasTag("monster")
            end
    end)
end--]]


local function onsave(inst, data)
	if inst.components.knownlocations:GetLocation("home") then
	local dpt = inst.components.knownlocations:GetLocation("home") 
	print("setting data home..x"..dpt.x.."z."..dpt.z)
		data.x1 = dpt.x
		data.z1 = dpt.z
	end
end

local function onload(inst, data)
	print("=====================ON LOAD==============")
	if data and data.x1 and data.z1 then
	---local dpt =,0,data.z1
	print("moving to data home..x".. data.x1.."z.".. data.z1)
	inst.Transform:SetPosition(data.x1, 0, data.z1)
	end
---	inst.components.health:DoDelta(1)

end





local function OnAttacked(inst, data)


    if GetClock():IsNight() then
		if inst.LightWatcher:GetLightValue() < 0.35 then

				inst.sg:GoToState("dolongaction")
				local rabbit = SpawnPrefab("campfire")
				rabbit.Transform:SetPosition(inst.Transform:GetWorldPosition())


		end

    end


    local attacker = data.attacker

	if not inst:HasTag("cdlf") and attacker.components.health.currenthealth > 1 then
	inst:AddTag("cdlf")
	inst.components.combat:SetTarget(attacker)
	inst:DoTaskInTime(3, function() 
    inst:RemoveTag("cdlf")
    end)
	end
end


local function GiveItem(inst,weapon,armor,hat)
        local weapon = SpawnPrefab(weapon)     --------сюда вбивай оружие/инструмент  в ковычках типо "axe"
		weapon.persists = false
        weapon:AddComponent("finiteuses")
        weapon.components.finiteuses:SetMaxUses(TUNING.SPEAR_USES*999999999)
        weapon.components.finiteuses:SetUses(TUNING.SPEAR_USES*999999999)
    weapon:AddComponent("tool")
		    weapon.components.tool:SetAction(ACTIONS.CHOP, 1)
    weapon.components.tool:SetAction(ACTIONS.MINE, 1)
    weapon.components.tool:SetAction(ACTIONS.DIG, 1)
	    weapon.components.inventoryitem.keepondeath = true

    weapon.components.finiteuses:SetConsumption(ACTIONS.CHOP, 0)
    weapon.components.finiteuses:SetConsumption(ACTIONS.MINE, 0)
        inst.components.inventory:Equip(weapon)
		if armor then
		        local weapon = SpawnPrefab(armor)         --------сюда вбивай одежду  в ковычках типо "armorwood"
		weapon.persists = false
        weapon:AddComponent("finiteuses")
	    weapon.components.inventoryitem.keepondeath = true
        weapon.components.finiteuses:SetMaxUses(TUNING.SPEAR_USES*999999999)
        weapon.components.finiteuses:SetUses(TUNING.SPEAR_USES*999999999)
        inst.components.inventory:Equip(weapon)		
		end
		if hat then
     ---- hat
        local weapon = SpawnPrefab(hat)         --------сюда вбивай ikzge  в ковычках типо "tophat"
		weapon.persists = false
        weapon:AddComponent("finiteuses")
        weapon.components.finiteuses:SetMaxUses(TUNING.SPEAR_USES*999999999)
        weapon.components.finiteuses:SetUses(TUNING.SPEAR_USES*999999999)
        inst.components.inventory:Equip(weapon)	
	    weapon.components.inventoryitem.keepondeath = true
		end
end

local function EquipWeapon(inst,weapon,armor,hat)
    if not inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) then
        local weapon = SpawnPrefab(weapon)     --------сюда вбивай оружие/инструмент  в ковычках типо "axe"
		weapon.persists = false
        weapon:AddComponent("finiteuses")
        weapon.components.finiteuses:SetMaxUses(TUNING.SPEAR_USES*999999999)
        weapon.components.finiteuses:SetUses(TUNING.SPEAR_USES*999999999)
    weapon:AddComponent("tool")
		    weapon.components.tool:SetAction(ACTIONS.CHOP, 1)
    weapon.components.tool:SetAction(ACTIONS.MINE, 1)
    weapon.components.tool:SetAction(ACTIONS.DIG, 1)
	    weapon.components.inventoryitem.keepondeath = true

    weapon.components.finiteuses:SetConsumption(ACTIONS.CHOP, 0)
    weapon.components.finiteuses:SetConsumption(ACTIONS.MINE, 0)
        inst.components.inventory:Equip(weapon)
     ---- armor
	 
        local weapon = SpawnPrefab(armor)         --------сюда вбивай одежду  в ковычках типо "armorwood"
		weapon.persists = false
        weapon:AddComponent("finiteuses")
        weapon.components.finiteuses:SetMaxUses(TUNING.SPEAR_USES*999999999)
        weapon.components.finiteuses:SetUses(TUNING.SPEAR_USES*999999999)
        inst.components.inventory:Equip(weapon)		
		
			    weapon.components.inventoryitem.keepondeath = true

     ---- hat
        local weapon = SpawnPrefab(hat)         --------сюда вбивай ikzge  в ковычках типо "tophat"
		weapon.persists = false
        weapon:AddComponent("finiteuses")
        weapon.components.finiteuses:SetMaxUses(TUNING.SPEAR_USES*999999999)
        weapon.components.finiteuses:SetUses(TUNING.SPEAR_USES*999999999)
        inst.components.inventory:Equip(weapon)		
	 	    weapon.components.inventoryitem.keepondeath = true

	 
		--]]
    end
end

local function updatedamage(skelet)
skelet.components.combat:GiveUp()
if GetClock():IsDay() then
    skelet:AddTag("monster")
		if skelet.components.inventory:GetEquippedItem(EQUIPSLOTS.BODY) == "trunkvest_summer" then
	GiveItem(skelet,"axe",nil,"strawhat")
end
end

if skelet.components.inventory:GetEquippedItem(EQUIPSLOTS.BODY) == "backpack" then

        local weapon = SpawnPrefab("blowdart_walrus")
		weapon.persists = false
        weapon:AddComponent("finiteuses")
        weapon.components.finiteuses:SetMaxUses(TUNING.SPEAR_USES*999999999)
        weapon.components.finiteuses:SetUses(TUNING.SPEAR_USES*999999999)
    weapon:AddComponent("tool")
		    weapon.components.tool:SetAction(ACTIONS.CHOP, 1)
    weapon.components.tool:SetAction(ACTIONS.MINE, 1)
    weapon.components.tool:SetAction(ACTIONS.DIG, 1)

    weapon.components.finiteuses:SetConsumption(ACTIONS.CHOP, 0)
    weapon.components.finiteuses:SetConsumption(ACTIONS.MINE, 0)
        skelet.components.inventory:Equip(weapon)



end--]]
    if GetClock():IsDusk() then
	if skelet.components.inventory:GetEquippedItem(EQUIPSLOTS.BODY) == "trunkvest_summer" then
   --[[skelet:RemoveTag("monster")
       
	   skelet.sg:GoToState("dolongaction")
    local rabbit = SpawnPrefab("beebox")
    rabbit.Transform:SetPosition(skelet.Transform:GetWorldPosition())
	rabbit:AddComponent("lootdropper")
    rabbit.components.lootdropper:AddRandomLoot("petals_evil",0)
    rabbit.components.lootdropper.numrandomloot = 0
	rabbit:AddComponent("health")
	rabbit.components.health:SetMaxHealth(10000)
    rabbit.components.health:StartRegen(-11000, 120)

    local rabbit = SpawnPrefab("honey")
    rabbit.Transform:SetPosition(skelet.Transform:GetWorldPosition())
    local rabbit = SpawnPrefab("honey")
    rabbit.Transform:SetPosition(skelet.Transform:GetWorldPosition())

	GiveItem(skelet,"pitchfork",nil,"beehat")

    local rabbit = SpawnPrefab("campfire")
    rabbit.Transform:SetPosition(skelet.Transform:GetWorldPosition())
--]]
end
end

    if GetClock():IsNight() then
                skelet.sg:GoToState("dolongaction")
    local rabbit = SpawnPrefab("campfire")
    rabbit.Transform:SetPosition(skelet.Transform:GetWorldPosition())
end
end


local BUILDING = {"firepit","beebox","tent",
"slow_farmplot","fast_farmplot","treasurechest","treasurechest","treasurechest",
"homesign","birdcage","icebox","diviningrod",
"winterometer","rainometer","lightning_rod"}
-----firepit, beehive, trap,trap,trap, walls,craftingpit,chest,tent,slow_farmplot,fast_farmplot,


local function skwbuild(inst)
if math.random() < .35 then
inst.components.skw_build:build(inst,"get_random",0,0)
elseif math.random() < .1 then
inst.components.skw_build:build(inst,"get_random",0,true)
elseif math.random() < .2 then
inst.components.skw_build:build(inst,"get_random",0,0,0,true)
end
end



local function NormalRetargetFn(inst)
	if not GetClock():IsNight() then
    return FindEntity(inst, TUNING.PIG_TARGET_DIST/2,
        function(guy)
            if not guy.LightWatcher or guy.LightWatcher:IsInLight() then---player
                return guy:HasTag("monster") and guy.components.health and not guy.components.health:IsDead() and inst.components.combat:CanTarget(guy) and not 
                (inst.components.follower.leader ~= nil and guy:HasTag("abigail"))
            end
        end)
	else
    return FindEntity(inst, TUNING.PIG_TARGET_DIST/2,
        function(guy)
            if not guy.LightWatcher or guy.LightWatcher:IsInLight() then
                return guy:HasTag("monster") and guy.components.health and not guy.components.health:IsDead() and inst.components.combat:CanTarget(guy) and not 
                (inst.components.follower.leader ~= nil and guy:HasTag("abigail"))
            end
        end)
		
	end
end


local function NormalKeepTarget(inst, target)
    --give up on dead guys, or guys in the dark, or werepigs
    return inst.components.combat:CanTarget(target)
           and (not target.LightWatcher or target.LightWatcher:IsInLight())
           and not (target.sg and target.sg:HasStateTag("transform") )
end


local MAX_CHASEAWAY_DIST = 2
local function KeepTarget(inst, target)

    if (inst.components.follower and inst.components.follower.leader) then
        return true
    end

    local homePos = inst.components.knownlocations:GetLocation("home")
    local targetPos = Vector3(target.Transform:GetWorldPosition() )
    return homePos and distsq(homePos, targetPos) < MAX_CHASEAWAY_DIST*MAX_CHASEAWAY_DIST
end





local function Make(typeof,weapon,armor,hat)
    
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	local sound = inst.entity:AddSoundEmitter()
	local shadow = inst.entity:AddDynamicShadow()
	local whoisplayer = GetPlayer()
	
	---inst.animnum = math.random(#WEAPONS)
	----inst.OnLoad = onload
----	inst.OnSave = onsave


	shadow:SetSize( 1.5, .75 )
    inst.Transform:SetFourFaced()
	
    MakeCharacterPhysics(inst, 30, .3)

    inst:AddTag("monster")
    inst:AddTag("skw")
    inst:AddTag("scarytoprey")
	    inst:AddTag("hostile")

     inst:AddTag("norizes")
    anim:SetBank("wilson")
    anim:SetBuild("wendy")
    --anim:PlayAnimation("idle_loop", true)
    
    ------------------------------------------
    inst:AddComponent("inspectable")

    inst:AddComponent("locomotor") -- locomotor must be constructed before the stategraph
	
            inst:AddComponent("thief")

    ------------------------------------------
    inst:AddComponent("talker")
    inst.components.talker.ontalk = ontalk
    inst.components.talker.fontsize = 37
    inst.components.talker.font = TALKINGFONT
    --inst.components.talker.colour = Vector3(133/255, 140/255, 167/255)
    inst.components.talker.offset = Vector3(0,-400,0)

    inst:AddComponent("eater")
    inst.components.eater:SetOmnivore()
	inst.components.eater:SetCanEatHorrible()
    inst.components.eater.strongstomach = true -- can eat monster meat!
    inst.components.eater:SetOnEatFn(OnEat)

    inst:AddComponent("trader")

    ------------------
    inst:AddComponent("health")
	inst.components.health.fire_damage_scale = 0

	
	inst:AddComponent("sanityaura")
    inst.components.sanityaura.aura = -TUNING.SANITYAURA_MED

    ------------------
    inst:AddComponent("temperature")
	inst.components.temperature.hurtrate = 0

    inst:AddComponent("combat")
    inst.components.combat:SetDefaultDamage(TUNING.UNARMED_DAMAGE)
    --inst.components.combat.hiteffectsymbol = "pig_torso"
    inst.components.combat:SetAttackPeriod(1)
    inst.components.combat:SetRetargetFunction(3, NormalRetargetFn)
    inst.components.combat:SetKeepTargetFunction(NormalKeepTarget)
    
    ------------------------------------------
   if typeof == 1 then
	inst.components.locomotor.runspeed = 4
    inst.components.locomotor.walkspeed = 3
    inst.components.health:SetMaxHealth(175)
	inst.components.combat:SetDefaultDamage(TUNING.UNARMED_DAMAGE*1.25)
	elseif typeof == 2 then
	inst.components.locomotor.runspeed = 6
    inst.components.locomotor.walkspeed = 5
	inst.components.health:SetMaxHealth(75)
	elseif typeof == 3 then
	inst.components.locomotor.runspeed = 5
    inst.components.locomotor.walkspeed = 5
	inst.components.health:SetMaxHealth(150)
	elseif typeof == 4 then
	inst.components.locomotor.runspeed = 5
    inst.components.locomotor.walkspeed = 4
	inst.components.health:SetMaxHealth(100)
	elseif typeof == 5 then
	inst.components.locomotor.runspeed = 5
    inst.components.locomotor.walkspeed = 4
	inst.components.health:SetMaxHealth(255)
	inst.components.combat:SetDefaultDamage(TUNING.UNARMED_DAMAGE*2)
	else
   end
	
	
	
    inst:AddComponent("inventory")
----    inst.components.inventory.dropondeath = false

	
	    inst:AddComponent("follower")
    inst.components.follower.maxfollowtime = 10


    ------------------------------------------
    inst.entity:AddLabel()
    inst.Label:SetFontSize(35)
    inst.Label:SetFont(DEFAULTFONT)
    inst.Label:SetPos(0,3,0)
    inst.Label:SetColour(1, 0.5, 0.5)
    inst.Label:Enable(true)
    ------------------------------------------

    ------------------------------------------
    inst.components.talker:StopIgnoringAll()
    ------------------------------------------
    ------------------------------------------
   
    inst:SetBrain(brain)

	        local lightwatch = inst.entity:AddLightWatcher()
        lightwatch:SetLightThresh(.2)
        lightwatch:SetDarkThresh(.05)

    inst:AddComponent("lootdropper")
--[[
    inst:AddComponent("trader")
    inst.components.trader:SetAcceptTest(ShouldAcceptItem)
    inst.components.trader.onaccept = OnGetItemFromPlayer
    inst.components.trader.onrefuse = OnRefuseItem
--]]
    inst.AnimState:Hide("ARM_carry") 
    inst.AnimState:Show("ARM_normal") 


    inst:AddComponent("knownlocations")
    
   inst:DoTaskInTime(5*FRAMES, function() inst.components.knownlocations:RememberLocation("home", Vector3(inst.Transform:GetWorldPosition()) ) end)
    inst:AddComponent("skw_build")
    local target = inst
    ----inst.components.skw_build:build(target,"campfire",0,0)

	
   ---- inst:DoTaskInTime(15, EquipWeapon(inst,weapon,armor,hat))
	
    inst.OnSave = onsave
    inst.OnLoad = onload
	
	
	if typeof == 1 then
------	print("skw_builder should build")
	inst:ListenForEvent( "dusktime", function() skwbuild(inst, nil,true) end , GetWorld())
    inst:ListenForEvent( "daytime", function() skwbuild(inst, nil,true) end , GetWorld())
    inst:ListenForEvent( "nighttime", function() skwbuild(inst, nil,true) end , GetWorld())
    end
	
	
	
    inst:ListenForEvent("attacked", OnAttacked)
    inst:ListenForEvent( "dusktime", function() updatedamage(inst) end , GetWorld())
    inst:ListenForEvent( "daytime", function() updatedamage(inst) end , GetWorld())
    inst:ListenForEvent( "nighttime", function() updatedamage(inst) end , GetWorld())
	
    inst:ListenForEvent("entity_death", function(world, data) ondeath(inst, data.inst) end, GetWorld())

    inst:SetStateGraph("SGskw")
   
    return inst
end

return Prefab("common/housewife", function() return Make(1,"axe","trunkvest_summer","strawhat") end , assets, prefabs)
