--[NEW] This is how we tell the game we've created a new prefab.
 PrefabFiles =
{
		"darkclone",
		--"galunswordfire",
		"stungray_galun",
		"rook_galun",
		"frog_galun"
	-------	"bishop_nightmare2"
	-----	"snowman"
}


Assets = 
{
	Asset("ATLAS", "images/inventoryimages/galunsword.xml"),

}


local Recipe = GLOBAL.Recipe
local Ingredient = GLOBAL.Ingredient
local RECIPETABS = GLOBAL.RECIPETABS
local STRINGS = GLOBAL.STRINGS
local TUNING = GLOBAL.TUNING
local ACTIONS = GLOBAL.ACTIONS
local Ingredient = GLOBAL.Ingredient
local RECIPETABS = GLOBAL.RECIPETABS
local STRINGS = GLOBAL.STRINGS
local TECH = GLOBAL.TECH
local STRINGS = GLOBAL.STRINGS
local ACTIONS = GLOBAL.ACTIONS
local Action = GLOBAL.Action
local require = GLOBAL.require






-----NOTES
STRINGS.NAMES.PAPNOTE = "Note"

STRINGS.DRINKFROM= "Drink"



STRINGS.NAMES.DARKCLONE = "You"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.DARKCLONE = {}
STRINGS.CHARACTERS.GENERIC.DESCRIBE.DARKCLONE.GENERIC = "Who are you?"
STRINGS.CHARACTERS.WX78.DESCRIBE.DARKCLONE = "MULTIPLY"
STRINGS.CHARACTERS.WILLOW.DESCRIBE.DARKCLONE = "Want to burn something?"
STRINGS.CHARACTERS.WICKERBOTTOM.DESCRIBE.DARKCLONE = "Go back!"
STRINGS.CHARACTERS.WOLFGANG.DESCRIBE.DARKCLONE = "Hey! Are you me?"
STRINGS.CHARACTERS.WENDY.DESCRIBE.DARKCLONE = "You are not my sister!"
STRINGS.CHARACTERS.DARKCLONE = {}

STRINGS.CLONE_TALK_ATTACK = {"Combat!","Suffer, worm!","Death comes!",
"Hide!","Run!","To arms!","Come at me!","Fight!","Get over here, eh!","Go for the eyes!",
"I'm going to stomp you dead!","It's you or me!","I will punch you!","Better you than me!",
"Into the dark...","Fate takes you.","So it must be.","I've seen the future: you are not in it.",
"I shall send you to the other side!","Die!","Strike!","Attack!","I'll kill you.","Return my items!",
"Give me your gold.","I'll send you to your gods!","Heaven awaits!","Come here, coward!","Coward!","Battle!",
"Meet you in Hell!","Leave this world!","I'm your fate!","Your end is already written!","No more delays!",
"It's your last day!","Pray your gods!","No mercy!","To the better place.","Your life ends!","I'll help you escape.",
"I will see your insides.", "Your time is over!", "I will take your place!", "Fade out!"}

STRINGS.CLONE_TALK_DEAD = {"And so I fade...", "I... fade...", "Lights out.", "My blood runs cold...",
"Let the sun burn me out.", "My spark fades.", "Ligh blinds me.", "So dark, can't see.",
"I see. God.", "I meet the creator.", "You won, Maxwell.", "I face. Death.", "Everlasting dream..."
}
STRINGS.NAMES.GALUNSWORD = "Madness glaive"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.GALUNSWORD = {}
STRINGS.CHARACTERS.GENERIC.DESCRIBE.GALUNSWORD.GENERIC = "Imagination to overfight reality."
STRINGS.RECIPE_DESC.GALUNSWORD = "Imagination to overfight reality!"







TUNING.DARKCLONE_TIMEOUT = TUNING.TOTAL_DAY_TIME









local function ShadowBladeHallucinationOnAttack(inst, owner, target)
	if owner.components.sanity and owner:HasTag("player") then
		if owner.activemove then return end
		if not (target:HasTag("wall") or target:HasTag("shadowcreature") or target:HasTag("sword_attacker")) then
			print("calling galun!!!")
			owner.components.galunmonsterspawner:GalunMobAttacker(1,owner.components.galunmonsterspawner,math.floor(math.random(0,3)),target)
			
			if math.random()<0.5 then
				owner.components.talker:Say(GLOBAL.STRINGS.WILSON_SHADOW_BLADE_HALLUN[math.random(#GLOBAL.STRINGS.WILSON_SHADOW_BLADE_HALLUN)])
			end
		else
			owner.components.sanity:DoDelta(-1)
		end
		if target:HasTag("sword_attacker") then
			owner.components.sanity:DoDelta(3)
			target:Remove()
		end
	end
end

local function ShadowBladeHallucinations(prefab)
	local inst = prefab
    inst.components.weapon:SetDamage(TUNING.NIGHTSWORD_DAMAGE*0.75)
    inst.components.weapon.onattack = ShadowBladeHallucinationOnAttack
    inst.components.finiteuses:SetMaxUses(TUNING.NIGHTSWORD_USES*1.15)
    inst.components.finiteuses:SetUses(TUNING.NIGHTSWORD_USES*1.25)
	
end
AddPrefabPostInit("nightsword", ShadowBladeHallucinations)


GLOBAL.STRINGS.WILSON_SHADOW_BLADE_HALLUN = {"Sweet insanity!","You see them... too","They come from my head.",
"My imagination comes!","They are real!","Not less real then you.","Feel the pain!","Shades come for you!",
"How real are you?","Your mind is weak.","Nightmares are all real!","See them!",
"Now you see them.","Who is insane now?","I dreamed them myself!",
"Face my fears!","See the dream!","Welcome to my nightmare!","Nap in the earth..."}



GLOBAL.STRINGS.S_CHAR_TALK_HELLO = {"Hello! I am Wilson...","Uh, hi! My name is Willow, I stuck here...1"}
GLOBAL.STRINGS.S_CHAR_TALK_LETSLIVE = {"I think it is easier to burn things together!"}



local function CallForDarkClone(inst)
	print("CALLING FOR DARKCLONE")
	
	
	
	local darkclone = inst.components.galunmonsterspawner:FindClone()
	if not darkclone and inst.components.sanity:GetPercent() < 0.5
     and inst.components.galunmonsterspawner.darkclone_timeout < 1 then
	
		inst.components.galunmonsterspawner.darkclone_timeout = 10
		inst.components.galunmonsterspawner:CreateDarkClone()
		print("CREATE DARKCLONE")
		
		inst:DoTaskInTime(3, function()
			if not inst.components.galunmonsterspawner:FindClone() then
				inst.components.galunmonsterspawner.darkclone_timeout = 10
			end
		end)
	else
		print("DARKCLONE NOT NEEDED")
	end
end

AddPrefabPostInit("world", function(inst)
	GLOBAL.assert( GLOBAL.GetPlayer() == nil )
	local player_prefab = GLOBAL.SaveGameIndex:GetSlotCharacter()

	-- Unfortunately, we can't add new postinits by now. So we have to do
	-- it the hard way...

	GLOBAL.TheSim:LoadPrefabs( {player_prefab} )
	local oldfn = GLOBAL.Prefabs[player_prefab].fn
	GLOBAL.Prefabs[player_prefab].fn = function()
		local inst = oldfn()
		inst:AddComponent("galunmonsterspawner")
		
		inst:DoPeriodicTask(TUNING.DARKCLONE_TIMEOUT/4, function()
			CallForDarkClone(inst)
		end)
		inst:ListenForEvent( "dusktime", function() CallForDarkClone(inst) end , GLOBAL.GetWorld())
		inst:ListenForEvent( "nighttime", function() CallForDarkClone(inst) end , GLOBAL.GetWorld())

		
		return inst
	end
end)


----------------------------------------

